ConstructedType (API documentation of hlt.language packages)
Date: 2013-01-30

hlt.language.design.types

## Class ConstructedType

- java.lang.Object
- - hlt.language.design.types.Type
  - - hlt.language.design.types.StaticType
    - - hlt.language.design.types.ConstructedType

- All Implemented Interfaces:
    Valuable
  Direct Known Subclasses:
    ArrayType, BoxableTypeConstant, CollectionType, FunctionType, TupleType

      public abstract class ConstructedType
      extends StaticType

  This this the mother of all constructed type classes. A constructed type is a type of the form `CONSTRUCTOR(...,e_i,...,T_j,....)` where `CONSTRUCTOR` is a type constructor and the `e_i`'s are expressions and `Tj`'s are types.

- - ### Field Summary

    - ### Fields inherited from class hlt.language.design.types.Type

      `ARRAY, BAG, BOOLEAN, BOXABLE, CHAR, CLASS, COLLECTION, CONSTANT, DEFINED, FUNCTION, INT, INT_RANGE, INT_SORT, LIST, NAMED_TUPLE, OBJECT_SORT, PARAMETER, REAL, REAL_RANGE, REAL_SORT, SET, STRING, TUPLE, VOID, VOID_SORT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConstructedType()`

  - ### Method Summary

    - ### Methods inherited from class hlt.language.design.types.Type

      `actualType, array, array, baseType, baseTypeRef, BOOLEAN, BOXED_BOOLEAN, BOXED_CHAR, BOXED_INT, BOXED_REAL, boxSort, CHAR, checkOccurrence, copy, copy, curry, eqCode, equals, findValue, flatten, getParameters, getParameters, getValue, instantiate, INT, is, isBag, isBoolean, isBoxedType, isChar, isCollection, isEqualTo, isEqualTo, isGlobalUnsafe, isInt, isList, isPolymorphic, isPrimitive, isReal, isSet, isString, isVoid, kind, kindString, numberOfTypeComponents, rank, REAL, resetNames, setBoxed, setTypeRefComponent, shadowType, sort, standardize, toFullString, toQuantifiedString, toQuantifiedString, typeComponent, typeRefComponent, unify, unify, unwrapper, value, wrapper`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ConstructedType

          public ConstructedType()